unit MainWin;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
type
  TMainFrm = class(TForm)
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    GameOver:boolean;
    Pole:array[1..3,1..3]of byte;
    KrestBm,NullBm,PoleBm:TBitmap;
    CoordX,CoordY,KolHod:byte;
    function Proverka(Pro:boolean;kod:byte):boolean;
  public
  end;
var
  MainFrm: TMainFrm;
const
  h=60;
implementation
{$R *.DFM}
procedure TMainFrm.FormShow(Sender: TObject);
var
  i,j:byte;
begin
  for i:=1 to 3 do for j:=1 to 3 do Pole[i,j]:=0;
  if Random(2)=0 then
  begin
    Pole[Random(3)+1,Random(3)+1]:=1;
    KolHod:=1;
  end
  else KolHod:=0;
  GameOver:=false;
  FormPaint(Sender);
end;
procedure TMainFrm.FormPaint(Sender: TObject);
var
  i,j:byte;
  k:shortint;
begin
  with PoleBm.Canvas do
  begin
    Brush.Color:=clSilver;
    FillRect(ClientRect);
    for k:=-1 to 1 do
    for i:=1 to 2 do
    begin
      MoveTo(0,h*i+k); LineTo(h*3,h*i+k);
      MoveTo(h*i+k,0); LineTo(h*i+k,h*3);
    end;
    for i:=1 to 3 do for j:=1 to 3 do
    if Pole[i,j]=1 then
      Draw((i-1)*h+(h-KrestBm.Width) div 2,
           (j-1)*h+(h-KrestBm.Height) div 2,KrestBm)
    else if Pole[i,j]=2 then
      Draw((i-1)*h+(h-NullBm.Width) div 2,
           (j-1)*h+(h-NullBm.Height) div 2,NullBm);
  end;
  Canvas.Draw(0,0,PoleBm);
end;
procedure TMainFrm.FormCreate(Sender: TObject);
begin
  Randomize;
  KrestBm:=TBitmap.Create;
  NullBm:=TBitmap.Create;
  KrestBm.LoadFromResourceName(hInstance,'KREST');
  NullBm.LoadFromResourceName(hInstance,'NULL');
  KrestBm.Transparent:=true;
  NullBm.Transparent:=true;
  PoleBm:=TBitmap.Create;
  PoleBm.Width:=h*3;
  PoleBm.Height:=h*3;
  ClientHeight:=h*3;
  ClientWidth:=h*3;
end;
procedure TMainFrm.FormDestroy(Sender: TObject);
begin
  KrestBm.Destroy;
  NullBm.Destroy;
  PoleBm.Destroy;
end;
procedure TMainFrm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i,j:byte;
begin
  if Button=mbLeft then
  for i:=0 to 2 do for j:=0 to 2 do
  if (X>i*h)and(X<i*h+h)and(Y>j*h)and(Y<j*h+h) then
  begin
    CoordX:=i; CoordY:=j;
  end;
end;
procedure TMainFrm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if GameOver then
  begin
    FormShow(Sender);
    exit;
  end;
  if Button=mbLeft then
  if (X>CoordX*h)and(X<CoordX*h+h)and(Y>CoordY*h)and(Y<CoordY*h+h) then
  if Pole[CoordX+1,CoordY+1]=0 then
  begin
    Pole[CoordX+1,CoordY+1]:=2;
    FormPaint(Sender);
    inc(KolHod);
    if Proverka(true,2) then
    begin
      GameOver:=true;
      ShowMessage('You');
      exit;
    end;
    GameOver:=KolHod=9;
    if not GameOver then
    begin
      Proverka(false,1);
      inc(KolHod);
      GameOver:=KolHod=9;
      FormPaint(Sender);
      if Proverka(true,1) then
      begin
        GameOver:=true;
        ShowMessage('Comp');
        exit;
      end;
    end;
  end;
end;
function TMainFrm.Proverka(Pro:boolean;kod:byte): boolean;
function Horiz(kol,kol0,kod:byte):boolean;
var
  i,j,k,k0,x,y:byte;
begin
  for i:=1 to 3 do
  begin
    k:=0; k0:=0;
    for j:=1 to 3 do
      if Pole[i,j]=kod then inc(k)
      else
      if Pole[i,j]=0 then
      begin
        x:=i; y:=j; inc(k0);
      end;
    if (k=kol)and(k0=kol0) then
    begin
      if k0<>0 then Pole[x,y]:=1;
      Result:=true;
      exit;
    end;
  end;
  Result:=false;
end;
function Vertik(kol,kol0,kod:byte):boolean;
var
  i,j,k,k0,x,y:byte;
begin
  for j:=1 to 3 do
  begin
    k:=0; k0:=0;
    for i:=1 to 3 do
      if Pole[i,j]=kod then inc(k)
      else
      if Pole[i,j]=0 then
      begin
        x:=i; y:=j; inc(k0);
      end;
    if (k=kol)and(k0=kol0) then
    begin
      if k0<>0 then Pole[x,y]:=1;
      Result:=true;
      exit;
    end;
  end;
  Result:=false;
end;
function Diag1(kol,kol0,kod:byte):boolean;
var
  i,k,k0,x,y:byte;
begin
  k:=0; k0:=0;
  for i:=1 to 3 do
  begin
    if Pole[i,i]=kod then inc(k)
    else
    if Pole[i,i]=0 then
    begin
      x:=i; y:=i; inc(k0);
    end;
  end;
  if (k=kol)and(k0=kol0) then
  begin
    if k0<>0 then Pole[x,y]:=1;
    Result:=true;
    exit;
  end;
  Result:=false;
end;
function Diag2(kol,kol0,kod:byte):boolean;
var
  i,k,k0,x,y:byte;
begin
  k:=0; k0:=0;
  for i:=1 to 3 do
  begin
    if Pole[4-i,i]=kod then inc(k)
    else
    if Pole[4-i,i]=0 then
    begin
      x:=4-i; y:=i; inc(k0);
    end;
  end;
  if (k=kol)and(k0=kol0) then
  begin
    if k0<>0 then Pole[x,y]:=1;
    Result:=true;
    exit;
  end;
  Result:=false;
end;
function ProComp(i:byte):boolean;
begin
  Result:=true;
  if Horiz(i,3-i,1) then exit;
  if Vertik(i,3-i,1) then exit;
  if Diag1(i,3-i,1) then exit;
  if Diag2(i,3-i,1) then exit;

  if i=2 then
  begin
    if Horiz(i,3-i,2) then exit;
    if Vertik(i,3-i,2) then exit;
    if Diag1(i,3-i,2) then exit;
    if Diag2(i,3-i,2) then exit;
  end;
  Result:=false;
end;
var
  i,j:byte;
begin
  Result:=true;
  if Pro then
  begin
    if Horiz(3,0,kod) then exit;
    if Vertik(3,0,kod) then exit;
    if Diag1(3,0,kod) then exit;
    if Diag2(3,0,kod) then exit;
  end
  else 
  begin
    for i:=2 downto 1 do if ProComp(i) then exit;
    while true do
    begin
      i:=Random(3)+1; j:=Random(3)+1;
      if Pole[i,j]=0 then
      begin
        Pole[i,j]:=1;
        exit;
      end;
    end;
  end;
  Result:=false;
end;
end.
